## globalplatform 2.3.1+dfsg

=== globalplatform/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.5.1)
PROJECT(globalplatform C)

cmake_policy(VERSION 3.5.1)

SET( ${PROJECT_NAME}_CURRENT 7 )
SET( ${PROJECT_NAME}_REVISION 3 )
SET( ${PROJECT_NAME}_AGE 0 )
SET(VERSION "${${PROJECT_NAME}_CURRENT}.${${PROJECT_NAME}_REVISION}.${${PROJECT_NAME}_AGE}")

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/)

set(CMAKE_MACOSX_RPATH 1)

IF(UNIX)
    # Create PkgConfig file
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/globalplatform.pc.in ${CMAKE_CURRENT_BINARY_DIR}/globalplatform.pc @ONLY)
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig COMPONENT dev)
ENDIF(UNIX)

IF(UNIX)
  set(DOCUMENTATION_DIRECTORY "share/doc/lib${PROJECT_NAME}${${PROJECT_NAME}_CURRENT}")
ELSE(UNIX)
  set(DOCUMENTATION_DIRECTORY "doc")
ENDIf(UNIX)

set(DOXYFILE_SOURCE_DIR ${PROJECT_SOURCE_DIR}/src)
set(DOXYFILE_LATEX OFF)
include(UseDoxygen)

set(INSTALL_FILES	${CMAKE_CURRENT_SOURCE_DIR}/AUTHORS ${CMAKE_CURRENT_SOURCE_DIR}/ChangeLog
              ${CMAKE_CURRENT_SOURCE_DIR}/COPYING ${CMAKE_CURRENT_SOURCE_DIR}/COPYING.LESSER
              ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.OpenSSL
              ${CMAKE_CURRENT_SOURCE_DIR}/NEWS ${CMAKE_CURRENT_SOURCE_DIR}/README.md)

INSTALL(FILES ${INSTALL_FILES} DESTINATION ${DOCUMENTATION_DIRECTORY})

INSTALL(FILES ${INSTALL_FILES} DESTINATION ${DOCUMENTATION_DIRECTORY}
              COMPONENT dev)

INSTALL(
CODE "FILE (GLOB_RECURSE ALL_DOCS \"${CMAKE_CURRENT_BINARY_DIR}/doc/html/*\")"
CODE "FILE (INSTALL DESTINATION \"\${CMAKE_INSTALL_PREFIX}/${DOCUMENTATION_DIRECTORY}/html\" TYPE FILE FILES \${ALL_DOCS})"
COMPONENT dev)

# build a CPack driven installer package

IF(WIN32)
set(CPACK_GENERATOR "ZIP")
set(CPACK_SOURCE_GENERATOR "ZIP")
ELSE(WIN32)
set(CPACK_GENERATOR "TGZ")
set(CPACK_SOURCE_GENERATOR "TGZ")
ENDIF(WIN32)

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY  "The GlobalPlatform Library is a smart card management library for OpenPlatform 2.0.1' and GlobalPlatform 2.1.1 smart cards and later")
set(CPACK_PACKAGE_FILE_NAME            "${PROJECT_NAME}-binary-${VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY    "${PROJECT_NAME}-${VERSION}")
set(CPACK_PACKAGE_VENDOR               "Karsten Ohme")
set(CPACK_PACKAGE_CONTACT              "Karsten Ohme <k_o_@users.sourceforge.net>")
set(CPACK_PACKAGE_VERSION              "${VERSION}")

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.LESSER")
set(CPACK_PACKAGE_VERSION_MAJOR        "${${PROJECT_NAME}_CURRENT}")
set(CPACK_PACKAGE_VERSION_MINOR        "${${PROJECT_NAME}_REVISION}")
set(CPACK_PACKAGE_VERSION_PATCH        "${${PROJECT_NAME}_AGE}")
set(CPACK_SOURCE_IGNORE_FILES "doc;.*~;Debian;debian;\\\\.svn;\\\\.settings;Testing;CMakeFiles;Doxyfile;
CPack.*;CMakeCache\\\\.txt;cmake_install.*;Makefile;CMakeDoxyfile\\\\.in;
_.*;\\\\.cproject;\\\\.project;DartConfiguration.tcl;.*vcxproj.*;.*patch;
\\\\.manifest;.*Test;\\\\.pc;description\\\\.txt;\\\\.sh;\\\\.cmake;install.*;
\\\\.tar\\\\.gz;\\\\.zip;\\\\.lib;\\\\.ilk;\\\\.pdb;\\\\.exe;\\\\.exp;\\\\.a;\\\\.so;\\\\.dll;\\\\.lib$;
Doxyfile$;${CPACK_SOURCE_IGNORE_FILES}")

include(CPack)

IF(TESTING)
    ENABLE_TESTING()
ENDIF()

ADD_SUBDIRECTORY(src)

=== gppcscconnectionplugin/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.5.1)
PROJECT(gppcscconnectionplugin C)

cmake_policy(VERSION 3.5.1)

SET( ${PROJECT_NAME}_CURRENT 1 )
SET( ${PROJECT_NAME}_REVISION 2 )
SET( ${PROJECT_NAME}_AGE 4 )
SET(VERSION "${${PROJECT_NAME}_CURRENT}.${${PROJECT_NAME}_REVISION}.${${PROJECT_NAME}_AGE}")

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/;${PROJECT_SOURCE_DIR}/../globalplatform/cmake_modules/)

set(CMAKE_MACOSX_RPATH 1)

IF(UNIX)
  set(DOCUMENTATION_DIRECTORY "share/doc/lib${PROJECT_NAME}${${PROJECT_NAME}_CURRENT}")
ELSE(UNIX)
  set(DOCUMENTATION_DIRECTORY "doc")
ENDIf(UNIX)

INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/AUTHORS ${CMAKE_CURRENT_SOURCE_DIR}/ChangeLog
              ${CMAKE_CURRENT_SOURCE_DIR}/COPYING ${CMAKE_CURRENT_SOURCE_DIR}/COPYING.LESSER
              ${CMAKE_CURRENT_SOURCE_DIR}/NEWS ${CMAKE_CURRENT_SOURCE_DIR}/README.md DESTINATION ${DOCUMENTATION_DIRECTORY})

# build a CPack driven installer package

IF(WIN32)
set(CPACK_GENERATOR "ZIP")
set(CPACK_SOURCE_GENERATOR "ZIP")
ELSE(WIN32)
set(CPACK_GENERATOR "TGZ")
set(CPACK_SOURCE_GENERATOR "TGZ")
ENDIF(WIN32)

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY  "This is a PC/SC connection plugin for the GlobalPlatform Library.")
set(CPACK_PACKAGE_FILE_NAME            "${PROJECT_NAME}-binary-${VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY    "${PROJECT_NAME}-${VERSION}")
set(CPACK_PACKAGE_VENDOR               "Karsten Ohme")
set(CPACK_PACKAGE_CONTACT              "Karsten Ohme <k_o_@users.sourceforge.net>")
set(CPACK_PACKAGE_VERSION              "${VERSION}")

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.LESSER")
set(CPACK_PACKAGE_VERSION_MAJOR        "${${PROJECT_NAME}_CURRENT}")
set(CPACK_PACKAGE_VERSION_MINOR        "${${PROJECT_NAME}_REVISION}")
set(CPACK_PACKAGE_VERSION_PATCH        "${${PROJECT_NAME}_AGE}")
set(CPACK_SOURCE_IGNORE_FILES "doc;.*~;Debian;debian;\\\\.svn;\\\\.settings;Testing;CMakeFiles;Doxyfile;
CPack.*;CMakeCache\\\\.txt;cmake_install.*;Makefile;CMakeDoxyfile\\\\.in;
_.*;\\\\.cproject;\\\\.project;DartConfiguration.tcl;.*vcxproj.*;.*patch;
\\\\.manifest;.*Test;\\\\.pc;description\\\\.txt;\\\\.sh;\\\\.cmake;install.*;
\\\\.tar\\\\.gz;\\\\.zip;\\\\.lib;\\\\.ilk;\\\\.pdb;\\\\.exe;\\\\.exp;\\\\.a;\\\\.so;\\\\.dll;\\\\.lib$;
Doxyfile$;${CPACK_SOURCE_IGNORE_FILES}")

include(CPack)

ADD_SUBDIRECTORY(src)

=== gpshell/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.5.1)
PROJECT(gpshell C)

cmake_policy(VERSION 3.5.1)

SET( ${PROJECT_NAME}_CURRENT 2 )
SET( ${PROJECT_NAME}_REVISION 3 )
SET( ${PROJECT_NAME}_AGE 1 )
SET(VERSION "${${PROJECT_NAME}_CURRENT}.${${PROJECT_NAME}_REVISION}.${${PROJECT_NAME}_AGE}")

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/;${PROJECT_SOURCE_DIR}/../globalplatform/cmake_modules/)

set(CMAKE_MACOSX_RPATH 1)

IF(UNIX)
  set(DOCUMENTATION_DIRECTORY "share/doc/${PROJECT_NAME}${${PROJECT_NAME}_CURRENT}")
  set(MANPAGE_DIRECTORY "share/man")
ELSE(UNIX)
  set(DOCUMENTATION_DIRECTORY "doc")
ENDIF(UNIX)

INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/AUTHORS ${CMAKE_CURRENT_SOURCE_DIR}/ChangeLog
              ${CMAKE_CURRENT_SOURCE_DIR}/COPYING
              ${CMAKE_CURRENT_SOURCE_DIR}/README.md
              ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.OpenSSL
              ${CMAKE_CURRENT_SOURCE_DIR}/NEWS DESTINATION ${DOCUMENTATION_DIRECTORY})
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/helloworld.cap.transf DESTINATION ${DOCUMENTATION_DIRECTORY})
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/helloworld.cap DESTINATION ${DOCUMENTATION_DIRECTORY})

FILE(GLOB samples "${CMAKE_CURRENT_SOURCE_DIR}/*.txt")
LIST(REMOVE_ITEM samples "${CMAKE_CURRENT_SOURCE_DIR}/description.txt")
LIST(REMOVE_ITEM samples "${CMAKE_CURRENT_SOURCE_DIR}/CMakeList.txt")
LIST(REMOVE_ITEM samples "${CMAKE_CURRENT_SOURCE_DIR}/install_manifest.txt")
INSTALL(FILES ${samples} DESTINATION ${DOCUMENTATION_DIRECTORY})

# build a CPack driven installer package

IF(WIN32)
set(CPACK_GENERATOR "ZIP")
set(CPACK_SOURCE_GENERATOR "ZIP")
ELSE(WIN32)
set(CPACK_GENERATOR "TGZ")
set(CPACK_SOURCE_GENERATOR "TGZ")
ENDIF(WIN32)

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY  "GPShell is a script interpreter which talks to a smart card. It is written on top of the GlobalPlatform library.")
set(CPACK_PACKAGE_FILE_NAME            "${PROJECT_NAME}-binary-${VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY    "${PROJECT_NAME}-${VERSION}")
set(CPACK_PACKAGE_VENDOR               "Karsten Ohme")
set(CPACK_PACKAGE_CONTACT              "Karsten Ohme <k_o_@users.sourceforge.net>")
set(CPACK_PACKAGE_VERSION              "${VERSION}")

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR        "${${PROJECT_NAME}_CURRENT}")
set(CPACK_PACKAGE_VERSION_MINOR        "${${PROJECT_NAME}_REVISION}")
set(CPACK_PACKAGE_VERSION_PATCH        "${${PROJECT_NAME}_AGE}")
set(CPACK_SOURCE_IGNORE_FILES "doc;.*~;Debian;debian;\\\\.svn;\\\\.settings;Testing;CMakeFiles;Doxyfile;
CPack.*;CMakeCache\\\\.txt;cmake_install.*;Makefile;CMakeDoxyfile\\\\.in;
_.*;\\\\.cproject;\\\\.project;DartConfiguration.tcl;.*vcxproj.*;.*patch;
\\\\.manifest;.*Test;\\\\.pc;description\\\\.txt;\\\\.sh;\\\\.cmake;install.*;
\\\\.tar\\\\.gz;\\\\.zip;\\\\.lib;\\\\.ilk;\\\\.pdb;\\\\.exe;\\\\.exp;\\\\.a;\\\\.so;\\\\.dll;\\\\.lib$;
Doxyfile$;${CPACK_SOURCE_IGNORE_FILES}")
set(CPACK_SOURCE_IGNORE_FILES "src/gpshell;${CPACK_SOURCE_IGNORE_FILES}")

include(CPack)

ADD_SUBDIRECTORY(src)

=== globalplatform/src/CMakeLists.txt ===
cmake_policy(SET CMP0045 NEW)

INCLUDE(FindPCSC)
INCLUDE(FindOpenSSL)
INCLUDE(FindZLIB)

SET(SOURCES connection.c stringify.c crypto.c loadfile.c util.c debug.c init.c globalplatform.c)


INCLUDE(CheckCCompilerFlag)
INCLUDE(CMakePushCheckState)

IF(DEBUG)
  SET(CMAKE_BUILD_TYPE "Debug")
  IF(MSVC_VERSION)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W4")
  ELSE()
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -O0 -Wall")
  ENDIF()

  # check for fsanitize support
  CMAKE_PUSH_CHECK_STATE()
  SET(CMAKE_REQUIRED_FLAGS "-fsanitize=address")
  check_c_compiler_flag("-fsanitize=address" FSANITIZE)
  CMAKE_POP_CHECK_STATE()
  IF(FSANITIZE)
  MESSAGE("fsanitize supported")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
  ENDIF()
  
  # check for Wpedantic support
  CMAKE_PUSH_CHECK_STATE()
  SET(CMAKE_REQUIRED_FLAGS "-Wpedantic")
  check_c_compiler_flag("-Wpedantic" PEDANTIC)
  CMAKE_POP_CHECK_STATE()
  IF(PEDANTIC)
  MESSAGE("pedantic supported")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpedantic")
  ENDIF()
  
ELSE(DEBUG)
  SET(CMAKE_BUILD_TYPE "Release")
ENDIF(DEBUG)

# Enable debugging output
ADD_DEFINITIONS(-DOPGP_DEBUG)

# Handle Unix build
IF(UNIX)
  SET(SOURCES ${SOURCES} dyn_unix.c)

  IF(USE_SYSTEM_MINIZIP)
    FIND_PACKAGE(PkgConfig)
    IF(PKG_CONFIG_FOUND)
      PKG_CHECK_MODULES(MINIZIP minizip)
    ENDIF(PKG_CONFIG_FOUND)
  ELSE(USE_SYSTEM_MINIZIP)
    SET(SOURCES ${SOURCES} unzip/ioapi.c unzip/unzip.c)
  ENDIF(USE_SYSTEM_MINIZIP)

  # Enable plugin loader
  ADD_DEFINITIONS(-DHAVE_DLFCN_H)

  # enable syslog
  include (CheckSymbolExists)
  CHECK_SYMBOL_EXISTS (vsyslog syslog.h HAVE_VSYSLOG)
    ADD_DEFINITIONS(-DHAVE_VSYSLOG)
  IF(HAVE_VSYSLOG)
  ENDIF(HAVE_VSYSLOG)
ENDIF(UNIX)

# Handle Windows build
IF(WIN32)
    SET(SOURCES ${SOURCES} DLLMain.c dyn_win32.c unzip/unzip.c unzip/iowin32.c unzip/ioapi.c version.rc)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS -DOPGP_EXPORTS -DZLIB_WINAPI)
    ADD_DEFINITIONS(-DUNICODE)
ENDIF(WIN32)

INCLUDE_DIRECTORIES(${PCSC_INCLUDE_DIRS} ${OPENSSL_INCLUDE_DIR} ${ZLIB_INCLUDE_DIRS})
IF(USE_SYSTEM_MINIZIP)
  INCLUDE_DIRECTORIES(${MINIZIP_INCLUDE_DIRS})
ENDIF(USE_SYSTEM_MINIZIP)

# without this the compilation in the homebrew docker image does not work
IF(UNIX)
  link_directories(${PCSC_LIBDIR})
ENDIF()

ADD_LIBRARY(globalplatformStatic STATIC ${SOURCES})
ADD_LIBRARY(globalplatform SHARED ${SOURCES})

SET(LIBRARIES ${PCSC_LIBRARIES} ${OPENSSL_LIBRARIES} ${ZLIB_LIBRARIES})

# Under Unix shared and static libraries can have the same name
IF(UNIX)
  SET_TARGET_PROPERTIES(globalplatformStatic PROPERTIES OUTPUT_NAME globalplatform)
  SET(LIBRARIES ${LIBRARIES} dl)
ENDIF(UNIX)
IF(USE_SYSTEM_MINIZIP)
  SET(LIBRARIES ${LIBRARIES} ${MINIZIP_LIBRARIES})
ENDIF(USE_SYSTEM_MINIZIP)

TARGET_LINK_LIBRARIES(globalplatform globalplatformStatic ${LIBRARIES})

IF(WINDDK_DIR)
  TARGET_LINK_LIBRARIES(globalplatform globalplatformStatic ${LIBRARIES} optimized ${WINDDK_DIR}/lib/win7/i386/msvcrt_win2000.obj optimized ${WINDDK_DIR}/lib/Crt/i386/msvcrt.lib)
ENDIF(WINDDK_DIR)

IF(UNIX)
  SET_TARGET_PROPERTIES(globalplatform PROPERTIES SOVERSION ${VERSION})
ENDIF(UNIX)

# Install
IF(WIN32)
 INSTALL(TARGETS globalplatformStatic ARCHIVE DESTINATION lib${LIB_SUFFIX} COMPONENT dev)
 INSTALL(TARGETS globalplatform RUNTIME DESTINATION lib${LIB_SUFFIX})
 INSTALL(TARGETS globalplatform ARCHIVE DESTINATION lib${LIB_SUFFIX} COMPONENT dev)
ELSE(WIN32)
# Static library must be build first, otherwise under Ubuntu Karmic the static build removes the .so file of the shared library version.
 INSTALL(TARGETS globalplatformStatic ARCHIVE DESTINATION lib${LIB_SUFFIX} COMPONENT dev)
 INSTALL(TARGETS globalplatform LIBRARY DESTINATION lib${LIB_SUFFIX})
ENDIF(WIN32)

# Testing
IF(TESTING)
    INCLUDE(FindCMocka)

    # gives /usr/bin/ld: /usr/lib/gcc/x86_64-linux-gnu/7/../../../x86_64-linux-gnu/libcheck_pic.a(check_pack.o): undefined reference to symbol '__pthread_unregister_cancel@@GLIBC_2.3.3'
    #INCLUDE_DIRECTORIES(${CHECK_INCLUDE_DIRS})
    #ADD_EXECUTABLE(globalplatformTest globalplatformTest.c)
    #TARGET_LINK_LIBRARIES(globalplatformTest globalplatform ${CHECK_LIBRARIES})
    #ADD_TEST(globalplatformTest ${EXECUTABLE_OUTPUT_PATH}/globalplatformTest)
    #SET_TESTS_PROPERTIES(globalplatformTest PROPERTIES PASS_REGULAR_EXPRESSION "Failures: 0")

  IF(CMOCKA_FOUND) 
    INCLUDE(AddCMockaTest)
    include(AddMockedTest)

    IF(UNIX AND NOT APPLE)
      add_mocked_test(scp03Test
        SOURCES scp03Test.c testUtil.c ${SOURCES}
        COMPILE_OPTIONS -I${PCSC_INCLUDE_DIRS}
        MOCKS RAND_bytes
        LINK_LIBRARIES ${LIBRARIES})

      add_mocked_test(scp02Test
        SOURCES scp02Test.c testUtil.c ${SOURCES}
        MOCKS RAND_bytes
        LINK_LIBRARIES ${LIBRARIES})

      add_mocked_test(scp01Test
        SOURCES scp01Test.c testUtil.c ${SOURCES}
        MOCKS RAND_bytes
        LINK_LIBRARIES ${LIBRARIES})
    ENDIF(UNIX AND NOT APPLE)

    add_cmocka_test(cryptoTest
      SOURCES cryptoTest.c testUtil.c ${SOURCES}
      LINK_LIBRARIES ${LIBRARIES})
    
    add_cmocka_test(statusTest
      SOURCES statusTest.c testUtil.c ${SOURCES}
      LINK_LIBRARIES ${LIBRARIES})
  ELSE()
    MESSAGE("cmocka not found - skipping tests.")
  ENDIF()
ENDIF(TESTING)


ADD_SUBDIRECTORY(globalplatform)

=== gppcscconnectionplugin/src/CMakeLists.txt ===
INCLUDE(FindPCSC)
INCLUDE(FindGlobalPlatform)
SET(SOURCES gppcscconnectionplugin.c "${PROJECT_SOURCE_DIR}/../globalplatform/src/util.c")

INCLUDE(CheckCCompilerFlag)
INCLUDE(CMakePushCheckState)

IF(DEBUG)
  SET(CMAKE_BUILD_TYPE "Debug")
  IF(MSVC_VERSION)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W4")
  ELSE()
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -O0 -Wall")
  ENDIF()

  # check for fsanitize support
  CMAKE_PUSH_CHECK_STATE()
  SET(CMAKE_REQUIRED_FLAGS "-fsanitize=address")
  check_c_compiler_flag("-fsanitize=address" FSANITIZE)
  CMAKE_POP_CHECK_STATE()
  IF(FSANITIZE)
  MESSAGE("fsanitize supported")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
  ENDIF()
  
  # check for Wpedantic support
  CMAKE_PUSH_CHECK_STATE()
  SET(CMAKE_REQUIRED_FLAGS "-Wpedantic")
  check_c_compiler_flag("-Wpedantic" PEDANTIC)
  CMAKE_POP_CHECK_STATE()
  IF(PEDANTIC)
  MESSAGE("pedantic supported")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpedantic")
  ENDIF()
  
ELSE(DEBUG)
  SET(CMAKE_BUILD_TYPE "Release")
ENDIF(DEBUG)

# Enable debugging output
ADD_DEFINITIONS(-DOPGP_DEBUG)

# Handle Windows build
IF(WIN32)
    SET(SOURCES ${SOURCES} version.rc)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
    ADD_DEFINITIONS(-DUNICODE)
ENDIF(WIN32)

# The last is needed to support a system where the globalplatform headers are already installed, but the util.h must still be found in the sub project of globalplatform
INCLUDE_DIRECTORIES(${PCSC_INCLUDE_DIRS} ${GLOBALPLATFORM_INCLUDE_DIRS} "${PROJECT_SOURCE_DIR}/../globalplatform/src")

# without this the compilation in the homebrew docker image does not work
IF(UNIX)
  link_directories(${PCSC_LIBDIR})
ENDIF()

ADD_LIBRARY(gppcscconnectionplugin SHARED ${SOURCES})
TARGET_LINK_LIBRARIES(gppcscconnectionplugin ${GLOBALPLATFORM_LIBRARIES} ${PCSC_LIBRARIES})

IF(WINDDK_DIR)
  TARGET_LINK_LIBRARIES(gppcscconnectionplugin ${GLOBALPLATFORM_LIBRARIES} ${PCSC_LIBRARIES} optimized ${WINDDK_DIR}/lib/win7/i386/msvcrt_win2000.obj optimized ${WINDDK_DIR}/lib/Crt/i386/msvcrt.lib)
ENDIF(WINDDK_DIR)

IF(UNIX)
  SET_TARGET_PROPERTIES(gppcscconnectionplugin PROPERTIES SOVERSION ${VERSION})
ENDIF(UNIX)

IF(WIN32)
  SET_TARGET_PROPERTIES(gppcscconnectionplugin PROPERTIES DEFINE_SYMBOL OPGP_PL_EXPORTS)
ENDIF(WIN32)

# Install
IF(WIN32)
 INSTALL(TARGETS gppcscconnectionplugin RUNTIME DESTINATION lib${LIB_SUFFIX})
 INSTALL(TARGETS gppcscconnectionplugin ARCHIVE DESTINATION lib${LIB_SUFFIX})
ELSE(WIN32)
 INSTALL(TARGETS gppcscconnectionplugin LIBRARY DESTINATION lib${LIB_SUFFIX})
ENDIF(WIN32)

# Testing
IF(TESTING)
  # gives /usr/bin/ld: /usr/lib/gcc/x86_64-linux-gnu/7/../../../x86_64-linux-gnu/libcheck_pic.a(check_pack.o): undefined reference to symbol '__pthread_unregister_cancel@@GLIBC_2.3.3'
  # https://github.com/libcheck/check/issues/48
  # PKG_CHECK_MODULES(CHECK check>=0.9.2)
#  IF(CHECK_FOUND)
#    INCLUDE_DIRECTORIES(${CHECK_INCLUDE_DIRS})
#    ADD_EXECUTABLE(gppcscconnectionpluginTest gppcscconnectionpluginTest.c)
#    TARGET_LINK_LIBRARIES(gppcscconnectionpluginTest gppcscconnectionplugin ${CHECK_LIBRARIES})
#    ADD_TEST(gppcscconnectionpluginTest ${EXECUTABLE_OUTPUT_PATH}/gppcscconnectionpluginTest)
#    SET_TESTS_PROPERTIES(gppcscconnectionpluginTest PROPERTIES PASS_REGULAR_EXPRESSION "Failures: 0")
#  ENDIF(CHECK_FOUND)
ENDIF(TESTING)

=== debian/changelog ===
globalplatform (2.3.1+dfsg-3) unstable; urgency=medium

  * Add Multi-Arch hints.
  * Ship example *.txt scripts in gpshell package.
  * Add upstream/metadata.
  * tests: Add 'lib' test of libraries.
  * tests: Add 'cli' test of gpshell.
  * libglobalplatform-dev: Depend on libpcsclite-dev.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 15 Nov 2023 08:44:51 +0100

globalplatform (2.3.1+dfsg-2) unstable; urgency=low

  * Drop self-checks on some archs due to upstream bug.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 14 Nov 2023 08:15:11 +0100

globalplatform (2.3.1+dfsg-1) unstable; urgency=low

  * Initial release.  Closes: #656665, #656959, #656957.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 09 Oct 2023 10:17:09 +0200

=== debian/control ===
Source: globalplatform
Section: devel
Priority: optional
Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 doxygen,
 libcmocka-dev,
 libminizip-dev,
 libpcsclite-dev,
 libssl-dev,
 pandoc,
 pkg-config,
 zlib1g-dev,
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/auth-team/globalplatform.git
Vcs-Browser: https://salsa.debian.org/auth-team/globalplatform
Homepage: https://kaoh.github.io/globalplatform/
Rules-Requires-Root: no

Package: gpshell
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: GlobalPlatform Shell smart card script interpreter
 GlobalPlatform is a standard for handling applets, keys and security
 of smart cards (see www.globalplatform.org).
 .
 GPShell (GlobalPlatform Shell) is a script interpreter which talks to
 a smart card.  It is written on top of the GlobalPlatform library,
 which was developed by Karsten Ohme.  It uses smart card
 communication protocols ISO-7816-4 and OpenPlatform 2.0.1 and
 GlobalPlatform 2.1.1.  It can establish a secure channel with a smart
 card, load, instantiate, delete, list applets on a smart card.
 .
 This package constains to gpshell command-line tool.

Package: libglobalplatform-dev
Section: libdevel
Architecture: any
Depends:
 libglobalplatform7 (= ${binary:Version}),
 libpcsclite-dev,
 ${misc:Depends},
Description: development files for the GlobalPlatform library
 GlobalPlatform is a standard for handling applets, keys and security
 of smart cards (see www.globalplatform.org).
 .
 This is a C library providing an API to access OpenPlatform 2.0.1' and
 GlobalPlatform 2.1.1 conforming smart cards and later.
 GlobalPlatform Library provides an API for all GlobalPlatform
 related functions. It also provides an connection plugin framework.
 .
 This package contains development files for the GlobalPlatform library.

Package: libglobalplatform7
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Recommends:
 libgppcscconnectionplugin1,
Description: library to handle communication with GlobalPlatform cards
 GlobalPlatform is a standard for handling applets, keys and security
 of smart cards (see www.globalplatform.org).
 .
 This is a C library providing an API to access OpenPlatform 2.0.1' and
 GlobalPlatform 2.1.1 conforming smart cards and later.
 GlobalPlatform Library provides an API for all GlobalPlatform
 related functions. It also provides an connection plugin framework.
 .
 This package contains the shared GlobalPlatform library.

Package: libgppcscconnectionplugin1
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: PC/SC connection plugin for GlobalPlatform Library
 GlobalPlatform is a standard for handling applets, keys and security
 of smart cards (see www.globalplatform.org).
 .
 This is a PC/SC connection plugin for the GlobalPlatform Library.
 This package provides a GlobalPlatform library/application a possibility
 to use PC/SC middleware/daemon to access smart cards.  It is used
 by gpshell for example.
 .
 This package contains the shared gppcscconnectionplugin library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --builddirectory=.

# https://github.com/kaoh/globalplatform/issues/84
ifeq ($(filter arm64 armel armhf mips64el ppc64el s390x alpha ia64 ppc64, $(DEB_HOST_ARCH)),)
unittest = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),,-DTESTING=ON)
endif

override_dh_auto_configure:
	dh_auto_configure -- \
	-DUSE_SYSTEM_MINIZIP=ON \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	$(unittest)

=== debian/tests/control ===
Tests: cli
Depends:
 gpshell,
 libgppcscconnectionplugin1,
 pcscd,

Tests: lib
Depends:
 gcc,
 libc-dev,
 libglobalplatform-dev,
 libgppcscconnectionplugin1,
 libssl-dev,
 pcscd,
 pkgconf,

## globalplatform 2.4.0%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: globalplatform
 Section: devel
 Priority: optional
-Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders:
  Simon Josefsson <simon@josefsson.org>,
 Build-Depends:
@@ -13,11 +13,11 @@
  libpcsclite-dev,
  libssl-dev,
  pandoc,
- pkg-config,
+ pkgconf,
  zlib1g-dev,
-Standards-Version: 4.6.2
-Vcs-Git: https://salsa.debian.org/auth-team/globalplatform.git
-Vcs-Browser: https://salsa.debian.org/auth-team/globalplatform
+Standards-Version: 4.7.0
+Vcs-Git: https://salsa.debian.org/pkg-security-team/globalplatform.git
+Vcs-Browser: https://salsa.debian.org/pkg-security-team/globalplatform
 Homepage: https://kaoh.github.io/globalplatform/
 Rules-Requires-Root: no
 
@@ -42,6 +42,7 @@
 Package: libglobalplatform-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends:
  libglobalplatform7 (= ${binary:Version}),
  libpcsclite-dev,

## globalplatform 2.4.0+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.5.1)
PROJECT(globalplatform C)

cmake_policy(VERSION 3.5.1)

# MacOS support for CMake 3+
set(CMAKE_MACOSX_RPATH 1)

ADD_SUBDIRECTORY(globalplatform)
ADD_SUBDIRECTORY(gppcscconnectionplugin)
ADD_SUBDIRECTORY(gpshell)

ADD_DEPENDENCIES(gppcscconnectionplugin globalplatform)
ADD_DEPENDENCIES(gpshell globalplatform gppcscconnectionplugin)

IF(TESTING)
    ENABLE_TESTING()
ENDIF()

=== globalplatform/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,10 @@
 cmake_policy(VERSION 3.5.1)
 
 SET( ${PROJECT_NAME}_CURRENT 7 )
-SET( ${PROJECT_NAME}_REVISION 3 )
+SET( ${PROJECT_NAME}_REVISION 4 )
 SET( ${PROJECT_NAME}_AGE 0 )
 SET(VERSION "${${PROJECT_NAME}_CURRENT}.${${PROJECT_NAME}_REVISION}.${${PROJECT_NAME}_AGE}")
+SET(SOVERSION "${${PROJECT_NAME}_CURRENT}")
 
 SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/)

=== gpshell/CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
 cmake_policy(VERSION 3.5.1)
 
 SET( ${PROJECT_NAME}_CURRENT 2 )
-SET( ${PROJECT_NAME}_REVISION 3 )
-SET( ${PROJECT_NAME}_AGE 1 )
+SET( ${PROJECT_NAME}_REVISION 4 )
+SET( ${PROJECT_NAME}_AGE 0 )
 SET(VERSION "${${PROJECT_NAME}_CURRENT}.${${PROJECT_NAME}_REVISION}.${${PROJECT_NAME}_AGE}")
 
 SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/;${PROJECT_SOURCE_DIR}/../globalplatform/cmake_modules/)

=== globalplatform/src/CMakeLists.txt ===
--- 
+++ 
@@ -107,7 +107,7 @@
 ENDIF(WINDDK_DIR)
 
 IF(UNIX)
-  SET_TARGET_PROPERTIES(globalplatform PROPERTIES SOVERSION ${VERSION})
+  SET_TARGET_PROPERTIES(globalplatform PROPERTIES SOVERSION ${SOVERSION})
 ENDIF(UNIX)
 
 # Install

=== gpshell/src/CMakeLists.txt ===
INCLUDE(FindPCSC)
INCLUDE(FindGlobalPlatform)
SET(SOURCES gpshell.c)

INCLUDE(CheckCCompilerFlag)
INCLUDE(CMakePushCheckState)

IF(DEBUG)
  SET(CMAKE_BUILD_TYPE "Debug")
  IF(MSVC_VERSION)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W4")
  ELSE()
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -O0 -Wall")
  ENDIF()

  # check for fsanitize support
  CMAKE_PUSH_CHECK_STATE()
  SET(CMAKE_REQUIRED_FLAGS "-fsanitize=address")
  check_c_compiler_flag("-fsanitize=address" FSANITIZE)
  CMAKE_POP_CHECK_STATE()
  IF(FSANITIZE)
  MESSAGE("fsanitize supported")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
  ENDIF()
  
  # check for Wpedantic support
  CMAKE_PUSH_CHECK_STATE()
  SET(CMAKE_REQUIRED_FLAGS "-Wpedantic")
  check_c_compiler_flag("-Wpedantic" PEDANTIC)
  CMAKE_POP_CHECK_STATE()
  IF(PEDANTIC)
  MESSAGE("pedantic supported")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpedantic")
  ENDIF()
  
ELSE(DEBUG)
  SET(CMAKE_BUILD_TYPE "Release")
ENDIF(DEBUG)

# Enable debugging output
ADD_DEFINITIONS(-DDEBUG)

# Handle Windows build
IF(WIN32)
    SET(SOURCES ${SOURCES} version.rc)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
    ADD_DEFINITIONS(-DUNICODE)
ENDIF(WIN32)

INCLUDE_DIRECTORIES(${PCSC_INCLUDE_DIRS} ${GLOBALPLATFORM_INCLUDE_DIRS})

# without this the compilation in the homebrew docker image does not work
IF(UNIX)
  link_directories(${PCSC_LIBDIR})
ENDIF()

ADD_EXECUTABLE(gpshell ${SOURCES})
TARGET_LINK_LIBRARIES(gpshell ${GLOBALPLATFORM_LIBRARIES} ${PCSC_LIBRARIES})

IF(WINDDK_DIR)
  TARGET_LINK_LIBRARIES(gpshell ${GLOBALPLATFORM_LIBRARIES} ${PCSC_LIBRARIES} optimized ${WINDDK_DIR}/lib/win7/i386/msvcrt_win2000.obj optimized ${WINDDK_DIR}/lib/Crt/i386/msvcrt.lib)
ENDIF(WINDDK_DIR)

# Install
INSTALL(TARGETS gpshell DESTINATION bin)

IF(NOT(WIN32))
	# pandoc man page generation
	
	if(NOT EXISTS ${PANDOC_EXECUTABLE})
	    message("-- Checking for pandoc")
	    find_program(PANDOC_EXECUTABLE pandoc)
	    mark_as_advanced(PANDOC_EXECUTABLE)
	    if(NOT EXISTS ${PANDOC_EXECUTABLE})
	        message(FATAL_ERROR "--   Pandoc not found. Install Pandoc (http://johnmacfarlane.net/pandoc/) or set cache variable PANDOC_EXECUTABLE.")
	        return()
	    else()
	        message("--   Found pandoc")
	    endif()
	endif()
	
	add_custom_command(
	    OUTPUT gpshell.1
	    COMMAND ${PANDOC_EXECUTABLE} --standalone --to man -o gpshell.1 gpshell.1.md
	    COMMENT "Creating man page ..."
	    )
	
	add_custom_target(gpshell_manpage ALL DEPENDS gpshell.1)
endif()

file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR}/gpshell.1 native_filepath)
get_directory_property(make_clean_files ADDITIONAL_MAKE_CLEAN_FILES)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${make_clean_files};${native_filepath}")

IF(UNIX)
  INSTALL(FILES gpshell.1 DESTINATION ${MANPAGE_DIRECTORY}/man1)
ENDIF(UNIX)

=== globalplatform/src/globalplatform/CMakeLists.txt ===
FILE(GLOB HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${HEADERS} DESTINATION include/globalplatform COMPONENT dev)

=== debian/changelog ===
globalplatform (2.4.0+dfsg-1ubuntu1) noble; urgency=medium

  * d/p/fix-ftbfs.patch: Disable LTO in unittests. (LP: #2060262)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 05 Apr 2024 20:31:05 +0200

globalplatform (2.4.0+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:04:53 +0000

globalplatform (2.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * use-MAJOR-version-as-SOVERSION.patch: Drop, fixed upstream.
  * fix-unitialized-value.patch: Drop, fixed upstream.
  * fix-rsa-exponent-conversion.patch: Drop, fixed upstream.
  * Update symbols file with added APIs.
  * use-versioned-so-for-dlopen.patch: Mark patch as forwarded.
  * use-system-minizip.patch: Tag Forwarded:not-needed with explanation.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 19 Dec 2023 11:07:31 +0100

globalplatform (2.3.1+dfsg-6) unstable; urgency=medium

  [ Ludovic Rousseau ]
  * Fix autopkgtest problem with pcscd. Closes: #1058770

 -- Simon Josefsson <simon@josefsson.org>  Sun, 17 Dec 2023 09:20:18 +0100

globalplatform (2.3.1+dfsg-5) unstable; urgency=medium

  * fix-rsa-exponent-conversion.patch: Add; fixing s390x FTBFS.

 -- Simon Josefsson <simon@josefsson.org>  Fri, 15 Dec 2023 09:28:48 +0100

globalplatform (2.3.1+dfsg-4) unstable; urgency=medium

  * Mark libglobalplatform-dev as Multi-Arch:same.
  * fix-unitialized-value.patch: Add; re-enable self-tests on all archs.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 20 Nov 2023 22:42:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: globalplatform
 Section: devel
 Priority: optional
-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
 Uploaders:
  Simon Josefsson <simon@josefsson.org>,
 Build-Depends:
@@ -13,11 +14,11 @@
  libpcsclite-dev,
  libssl-dev,
  pandoc,
- pkgconf,
+ pkg-config,
  zlib1g-dev,
-Standards-Version: 4.7.0
-Vcs-Git: https://salsa.debian.org/pkg-security-team/globalplatform.git
-Vcs-Browser: https://salsa.debian.org/pkg-security-team/globalplatform
+Standards-Version: 4.6.2
+Vcs-Git: https://salsa.debian.org/auth-team/globalplatform.git
+Vcs-Browser: https://salsa.debian.org/auth-team/globalplatform
 Homepage: https://kaoh.github.io/globalplatform/
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --builddirectory=.

unittest = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),,-DTESTING=ON)

override_dh_auto_configure:
	dh_auto_configure -- \
	-DUSE_SYSTEM_MINIZIP=ON \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	$(unittest)

=== debian/tests/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
  gpshell,
  libgppcscconnectionplugin1,
  pcscd,
+Restrictions: needs-sudo
 
 Tests: lib
 Depends:
@@ -13,3 +14,4 @@
  libssl-dev,
  pcscd,
  pkgconf,
+Restrictions: needs-sudo

## globalplatform 2.4.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,9 @@
 
 # MacOS support for CMake 3+
 set(CMAKE_MACOSX_RPATH 1)
+
+# With cmake >= 3.21, version can be set in project().
+set(GPSHELL_VERSION 2.4.2)
 
 ADD_SUBDIRECTORY(globalplatform)
 ADD_SUBDIRECTORY(gppcscconnectionplugin)

=== globalplatform/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 SET( ${PROJECT_NAME}_CURRENT 7 )
 SET( ${PROJECT_NAME}_REVISION 4 )
-SET( ${PROJECT_NAME}_AGE 0 )
+SET( ${PROJECT_NAME}_AGE 1 )
 SET(VERSION "${${PROJECT_NAME}_CURRENT}.${${PROJECT_NAME}_REVISION}.${${PROJECT_NAME}_AGE}")
 SET(SOVERSION "${${PROJECT_NAME}_CURRENT}")

=== gppcscconnectionplugin/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
 SET( ${PROJECT_NAME}_REVISION 2 )
 SET( ${PROJECT_NAME}_AGE 4 )
 SET(VERSION "${${PROJECT_NAME}_CURRENT}.${${PROJECT_NAME}_REVISION}.${${PROJECT_NAME}_AGE}")
+SET(SOVERSION "${${PROJECT_NAME}_CURRENT}")
 
 SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/;${PROJECT_SOURCE_DIR}/../globalplatform/cmake_modules/)

=== gpshell/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 SET( ${PROJECT_NAME}_CURRENT 2 )
 SET( ${PROJECT_NAME}_REVISION 4 )
-SET( ${PROJECT_NAME}_AGE 0 )
+SET( ${PROJECT_NAME}_AGE 2 )
 SET(VERSION "${${PROJECT_NAME}_CURRENT}.${${PROJECT_NAME}_REVISION}.${${PROJECT_NAME}_AGE}")
 
 SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/;${PROJECT_SOURCE_DIR}/../globalplatform/cmake_modules/)

=== globalplatform/src/CMakeLists.txt ===
--- 
+++ 
@@ -139,17 +139,19 @@
     IF(UNIX AND NOT APPLE)
       add_mocked_test(scp03Test
         SOURCES scp03Test.c testUtil.c ${SOURCES}
-        COMPILE_OPTIONS -I${PCSC_INCLUDE_DIRS}
+        COMPILE_OPTIONS -I${PCSC_INCLUDE_DIRS} "-fno-lto"
         MOCKS RAND_bytes
         LINK_LIBRARIES ${LIBRARIES})
 
       add_mocked_test(scp02Test
         SOURCES scp02Test.c testUtil.c ${SOURCES}
+        COMPILE_OPTIONS -I${PCSC_INCLUDE_DIRS} "-fno-lto"
         MOCKS RAND_bytes
         LINK_LIBRARIES ${LIBRARIES})
 
       add_mocked_test(scp01Test
         SOURCES scp01Test.c testUtil.c ${SOURCES}
+        COMPILE_OPTIONS -I${PCSC_INCLUDE_DIRS} "-fno-lto"
         MOCKS RAND_bytes
         LINK_LIBRARIES ${LIBRARIES})
     ENDIF(UNIX AND NOT APPLE)

=== gppcscconnectionplugin/src/CMakeLists.txt ===
--- 
+++ 
@@ -63,7 +63,7 @@
 ENDIF(WINDDK_DIR)
 
 IF(UNIX)
-  SET_TARGET_PROPERTIES(gppcscconnectionplugin PROPERTIES SOVERSION ${VERSION})
+  SET_TARGET_PROPERTIES(gppcscconnectionplugin PROPERTIES SOVERSION ${SOVERSION})
 ENDIF(UNIX)
 
 IF(WIN32)

=== gpshell/src/CMakeLists.txt ===
--- 
+++ 
@@ -79,9 +79,16 @@
 	    endif()
 	endif()
 	
+	# Inject version number
+	configure_file(
+		${CMAKE_CURRENT_SOURCE_DIR}/gpshell.1.md
+		${CMAKE_CURRENT_BINARY_DIR}/gpshell.1.md
+		@ONLY
+		)
+
 	add_custom_command(
 	    OUTPUT gpshell.1
-	    COMMAND ${PANDOC_EXECUTABLE} --standalone --to man -o gpshell.1 gpshell.1.md
+	    COMMAND ${PANDOC_EXECUTABLE} --standalone --to man -o gpshell.1 ${CMAKE_CURRENT_BINARY_DIR}/gpshell.1.md
 	    COMMENT "Creating man page ..."
 	    )
 	
@@ -93,5 +100,5 @@
 set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${make_clean_files};${native_filepath}")
 
 IF(UNIX)
-  INSTALL(FILES gpshell.1 DESTINATION ${MANPAGE_DIRECTORY}/man1)
+  INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/gpshell.1 DESTINATION ${MANPAGE_DIRECTORY}/man1)
 ENDIF(UNIX)

=== debian/changelog ===
globalplatform (2.4.2+dfsg-1) unstable; urgency=medium

  * New upstream version 2.4.2+dfsg
  * Standards-Version: 4.7.2.
  * Drop upstreamed use-versioned-so-for-dlopen.patch.
  * Drop upstreamed fix-ftbfs.patch.
  * Run wrap-and-sort -satbk.
  * Bump debian/* copyright years.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 10 Aug 2025 21:20:52 +0200

globalplatform (2.4.0+dfsg-3) unstable; urgency=medium

  * Fix reprotest failure.
  * Fix gpshell.1 paths.  Closes: #1079704.
  * Run wrap-and-sort -satbk.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 23 Sep 2024 22:32:50 +0200

globalplatform (2.4.0+dfsg-2) unstable; urgency=medium

  [ Simon Josefsson ]
  * Bump Standards-Version to 4.7.0.
  * Add debian/salsa-ci.yml for wrap-and-sort.
  * Change Maintainer to pkg-security and adjust Vcs-* URLs.
  * Build-Depends: Use pkgconf instead of pkg-config.
  * Bump d/copyright years.
  * d/gbp.conf: Add, for git branch names.

  [ Sudip Mukherjee <sudipm.mukherjee@gmail.com> ]
  * d/p/fix-ftbfs.patch: Disable LTO in unittests. (LP: #2060262)

 -- Simon Josefsson <simon@josefsson.org>  Thu, 04 Jul 2024 09:49:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,23 @@
 Source: globalplatform
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders:
  Simon Josefsson <simon@josefsson.org>,
 Build-Depends:
+ debhelper-compat (= 13),
  cmake,
- debhelper-compat (= 13),
  doxygen,
  libcmocka-dev,
  libminizip-dev,
  libpcsclite-dev,
  libssl-dev,
  pandoc,
- pkg-config,
+ pkgconf,
  zlib1g-dev,
-Standards-Version: 4.6.2
-Vcs-Git: https://salsa.debian.org/auth-team/globalplatform.git
-Vcs-Browser: https://salsa.debian.org/auth-team/globalplatform
+Standards-Version: 4.7.2
+Vcs-Git: https://salsa.debian.org/pkg-security-team/globalplatform.git
+Vcs-Browser: https://salsa.debian.org/pkg-security-team/globalplatform
 Homepage: https://kaoh.github.io/globalplatform/
 Rules-Requires-Root: no

=== debian/tests/control ===
Tests:
 cli,
Depends:
 gpshell,
 libgppcscconnectionplugin1,
 pcscd,
Restrictions:
 needs-sudo,

Tests:
 lib,
Depends:
 gcc,
 libc-dev,
 libglobalplatform-dev,
 libgppcscconnectionplugin1,
 libssl-dev,
 pcscd,
 pkgconf,
Restrictions:
 needs-sudo,

=== debian/watch ===
version=4
opts="dversionmangle=auto, repacksuffix=+dfsg" \
https://github.com/kaoh/globalplatform/tags (?:.*/)?(\d[\d\.]*)\.tar\.gz
